de.caff.generics.mda

## Interface ThreeDimensionalFloatReadAccess

- All Superinterfaces:
    MultiDimensional, MultiDimensionalReadAccess<java.lang.Float>, ThreeDimensionalReadAccess<java.lang.Float>
  All Known Subinterfaces:
    ThreeDimensionalFloatAccess
  All Known Implementing Classes:
    ThreeDimensionalFloatArray

      public interface ThreeDimensionalFloatReadAccess
      extends ThreeDimensionalReadAccess<java.lang.Float>

  Read access for 3-dimensional rectangular float arrays.
  Since:
    November 11, 2019
  Author:
    Rammi

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ThreeDimensionalFloatReadAccess` | `EMPTY` Empty 3dimensional float read access.

    - ### Fields inherited from interface de.caff.generics.mda.MultiDimensionalReadAccess

      `EMPTY0, EMPTY1, EMPTY2, EMPTY3, EMPTY4, EMPTY5, EMPTY6, EMPTY7`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default java.lang.Float` | `getElementAt(int ix, int iy, int iz)` Get the element at the given indexes.
    `float` | `getValueAt(int ix, int iy, int iz)` Get the value at the given indexes.
    `static ThreeDimensionalFloatReadAccess` | `singleton(float singleElement)` Get a 3dimensional float read access for a single element.
    `default TwoDimensionalFloatReadAccess` | `subAtX(int fixX)` Get a 2-dimensional view of the plane at the given X index.
    `default TwoDimensionalFloatReadAccess` | `subAtY(int fixY)` Get a 2-dimensional view of the plane at the given Y index.
    `default TwoDimensionalFloatReadAccess` | `subAtZ(int fixZ)` Get a 2-dimensional view of the plane at the given Z index.

    - ### Methods inherited from interface de.caff.generics.mda.ThreeDimensionalReadAccess

      `empty, getElement, getNumDimensions, getNumElements, getSize, getSizes, sizeX, sizeY, sizeZ, view, visitAll, visitAll`

    - ### Methods inherited from interface de.caff.generics.mda.MultiDimensionalReadAccess

      `empty, linearized`

- - ### Field Detail

    - #### EMPTY

          static final ThreeDimensionalFloatReadAccess EMPTY

      Empty 3dimensional float read access.

  - ### Method Detail

    - #### singleton

          @NotNull
          static ThreeDimensionalFloatReadAccess singleton(float singleElement)

      Get a 3dimensional float read access for a single element.
      Specified by:
        `singleton` in interface `ThreeDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `singleElement` - single element
      Returns:
        3dimensional float read access with size 1 in all 3 directions, containing just the given single element

    - #### getValueAt

          float getValueAt(int ix,
                           int iy,
                           int iz)

      Get the value at the given indexes.
      Parameters:
        `ix` - X index
        `iy` - Y index
        `iz` - Z index
      Returns:
        value at the given index

    - #### getElementAt

          @NotNull
          default java.lang.Float getElementAt(int ix,
                                                        int iy,
                                                        int iz)

      Description copied from interface: `ThreeDimensionalReadAccess`
      Get the element at the given indexes.
      Specified by:
        `getElementAt` in interface `ThreeDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `ix` - index in X direction from `0` (included) to `ThreeDimensionalReadAccess.sizeX()` (excluded)
        `iy` - index in Y direction from `0` (included) to `ThreeDimensionalReadAccess.sizeY()` (excluded)
        `iz` - index in Z direction from `0` (included) to `ThreeDimensionalReadAccess.sizeZ()` (excluded)
      Returns:
        element at the given indexes

    - #### subAtX

          @NotNull
          default TwoDimensionalFloatReadAccess subAtX(int fixX)

      Description copied from interface: `ThreeDimensionalReadAccess`
      Get a 2-dimensional view of the plane at the given X index. This is a view, so setting elements will change values in this array.
      Specified by:
        `subAtX` in interface `ThreeDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `fixX` - fix X index
      Returns:
        2-dimensional array at `fixX`

    - #### subAtY

          @NotNull
          default TwoDimensionalFloatReadAccess subAtY(int fixY)

      Description copied from interface: `ThreeDimensionalReadAccess`
      Get a 2-dimensional view of the plane at the given Y index. This is a view, so setting elements will change values in this array.
      Specified by:
        `subAtY` in interface `ThreeDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `fixY` - fix Y index
      Returns:
        2-dimensional array at `fixY`

    - #### subAtZ

          @NotNull
          default TwoDimensionalFloatReadAccess subAtZ(int fixZ)

      Description copied from interface: `ThreeDimensionalReadAccess`
      Get a 2-dimensional view of the plane at the given Z index. This is a view, so setting elements will change values in this array.
      Specified by:
        `subAtZ` in interface `ThreeDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `fixZ` - fix Z index
      Returns:
        2-dimensional array at `fixZ`